(* :Package Version: 1.5.23 *)

(* :Copyright: Copyright 2002, Selwyn Hollis *)

(* :Name: DiffEqs`MatrixTools` *)
 
(* :Author: Selwyn Hollis *)


BeginPackage["DiffEqs`MatrixTools`"]

TakeColumn::usage ="TakeColumn[matrix, n] returns as a list the nth column of matrix."

DropColumn::usage ="DropColumn[matrix, n] returns matrix with its nth column dropped.
DropColumn[matrix, {m, n}] drops columns m through n."

ReplaceColumn::usage ="ReplaceColumn[matrix, newcol, n] replaces the nth column of matrix with newcol.
newcol is input as a list."

AppendColumn::usage ="AppendColumn[matrix, newcol] appends newcol to matrix.
newcol is input as a list."

PrependColumn::usage ="PrependColumn[matrix, newcol] prepends newcol to matrix.
newcol is input as a list."

InsertColumn::usage ="InsertColumn[matrix, newcol, n] inserts newcol into matrix as the nth column.
newcol is input as a list."

Begin["`Private`"]

TakeColumn[(a_)?MatrixQ, n_Integer] := Transpose[a][[n]]; 

TakeColumn[(a_)?MatrixQ, {m_Integer, n_Integer}] := 
	Transpose[Transpose[a][[Range[m, n]]]]; 
	
DropColumn[(a_)?MatrixQ, n_Integer] := 
	Transpose[Drop[Transpose[a], {n}]]; 
	
DropColumn[(a_)?MatrixQ, {m_Integer, n_Integer}]:=
	Transpose[Drop[Transpose[a], {m, n}]]; 
	
ReplaceColumn[(a_)?MatrixQ, c_List, n_Integer] :=
	Transpose[ReplacePart[Transpose[a], c, n]]; 
	
AppendColumn[(a_)?MatrixQ, c_List] := 
	Transpose[Append[Transpose[a], c]]; 
	
PrependColumn[(a_)?MatrixQ, c_List] := 
	Transpose[Prepend[Transpose[a],c]]; 
	
InsertColumn[(a_)?MatrixQ, c_List, n_Integer] :=
	Transpose[Insert[Transpose[a], c, n]]; 

End[]

EndPackage[]
